#define Preview

#include <hidef.h>      /* common defines and macros */
#include <mc9s12e128.h>     /* derivative information */
#include <stdio.h>
#include <ADS12.h> 
#include <stdlib.h>
#include <S12E128bits.h> /* E128 bit definitions  */
#include <bitdefs.h> /* BIT0HI, BIT0LO....definitions */
#include <stdlib.h>

//Custom module includes
#include "Timers.h"
#include "PWM.h"
#include "InitPorts.h"
#include "SPI.h"
#include "DeadReckoning.h"
#include "Movement.h"
#include "Sensors.h"
#include <string.h>
#include <ctype.h>
#include "Gun.h"
#include "Gun_PID.h"

#define _ms_ *(187)   //187.5 cycles per ms for PWM_AS = (24million cycles/s) / (128)
#define PERIOD (1_ms_)  //187*10 < 65535   :)

#pragma LINK_INFO DERIVATIVE "SampleS12"

static int ActiveTargetArray[16] = 0;
static int Active = 0; // flag count for each target shoot

#ifdef Preview



void CheckSPI()
{
  unsigned char Response;
  int num, BeaconStatusFlag;
    //Response = SPI_Transmit_And_Receive2(0xAA);
    if ( SPI_TIMER_EXPIRE )
    {
        Response = SPI_Transmit_And_Receive2(0xAA);
        if (ResponseDecoder(Response) == EV_RECIEVED_TARGET) 
        {
          num = (unsigned int)(Response & 0b00001111);
          printf("num is %i\r\n", num);
          ActiveTargetArray[num] = 1;
          Request_IR_Illumination(num);
          BeaconStatusFlag = 1;  // Look for hit target
        } 
        // Reset timer
        TIM2_TC5 = TIM2_TCNT + (10 _ms_);
        TIM2_TFLG1 = _S12_C5F; //Clear the OC2 flag
    } 
}
/*char RotateToTarget(char Target) 
{
    if  
}*/

void MoveForwardDistance()
{   
int i = 0;
  printf("Start move forward\r\n");
  
    LeftSpeed(97);
    RightSpeed(100);
    for (i=0; i<100000; i++)
    {
      LeftSpeed(97);
      RightSpeed(100); 
    }
    LeftSpeed(0);
    RightSpeed(0); 
}

void CheckBeacon() 
{ 
    while(1) 
    {  
      if(PTIAD & BIT5HI == 1) 
      {
          PTIAD |= BIT4HI; // Light LED
          LeftSpeed(0);
          RightSpeed(0);
          //return 1;  
      }
      else 
      {
          PTIAD &= BIT4LO;
          //return 0;
      }
    }
}

char RotateToBeacon2() 
{
    PTIAD &= BIT4LO;
    LeftSpeed(-97);
    RightSpeed(100);
    if(PTIAD & BIT5HI == 1) 
    {
        PTIAD |= BIT4HI; // Light LED
        LeftSpeed(0);
        RightSpeed(0);
        while(1)
        {
          CheckBeacon(); 
        }
        return 1;  
    }
    else 
    {
        return 0;
    }
}



void main (void)
{
  InitPorts();
  InitPWM();
  InitTimers();
  SPIM_InitializeSPI();
  
  GunSpeed(50);
  PWMDTY2 = 150;
  while(1)
  {
    int num;
    CheckSPI();
    if(ActiveTargetArray[0] == 1)
    {
      MoveForwardDistance();  // move forward x distance and stop
      printf("Done forward\r\n");
      Release_Ball();
      printf("Done release ball\r\n");
      ActiveTargetArray[0] == 2; // Assume we hit the target
    }
    if(ActiveTargetArray[7] == 1)
    {
      RotateToBeacon2();  
    }
    
  }
}

#endif
