//Initializes all the ports that aren't used by the timers or PWM

#include "InitPorts.h"

#include <mc9s12e128.h>     /* derivative information */
#include <ADS12.h>  
#include <S12E128bits.h> /* E128 bit definitions  */
#include <bitdefs.h> /* BIT0HI, BIT0LO....definitions */
#include <stdio.h>


void InitPorts(void){
   
   (void)printf("Initializing ports\n\r");
   //Port assignments
   
   //Dealt with in InitPWM
   //Main cannon on U1
   //Left MotorHigh Drive U1  //Left Motor Speed Control
   //Left MotorLow  Drive U2  //Right Motor Speed Control
   
   
   
   //Right MotorHigh Drive U1 //Left Dir Pin
   DDRP = DDRP | BIT1HI;
   //Right MotorLow Drive U2  //Right Dir Pin
   DDRP = DDRP | BIT2HI;
   
   //Actuators to control ammo feed
   //Upper Gate: P4
   DDRP = DDRP | BIT4HI;
   //Lower Gate: P3
   DDRP = DDRP | BIT3HI;
   
   //Tape Sensors
   DDRS = DDRS & BIT3LO;  //Middle
   DDRS = DDRS & BIT2LO;  //Front Left
   DDRP = DDRP & BIT5LO;  //Front Middle
   DDRP = DDRP & BIT0LO;  //Front Right
   
   
   //IR Sensor  AD7, AD6
   //Tape Sensor   AD0, AD1, AD2, AD3
   //AD1,2,3 for tape sensors
   (void)ADS12_Init("IIIOIIII");
 }