#include <mc9s12e128.h>     /* derivative information */
#include <S12E128bits.h> /* E128 bit definitions  */
#include <stdio.h>

#include "PWM.h"

#define PWM_PERIOD (255) 


void InitPWM(void) {

  (void) printf("Initializing PWM\n\r");

  //////////////////////////System A/////////////////////
  PWMPRCLK = (_S12_PCKA0 | _S12_PCKA1 |_S12_PCKA2);  //Set PreScaler A to 2
  PWMSCLA = 426;      //Set Post scale factor A
    
  //Right Wheel Motor - Port U0
  MODRR = MODRR|_S12_MODRR0;   //Set PWM1 (U1) to be a PWM port
  PWME = PWME|_S12_PWME0;  //Enable Pulse Width Channel on PWM1
  PWMPOL |= _S12_PPOL0;   //Sets polarity high duty cycle for PWM1
  PWMCLK = PWMCLK | _S12_PCLK0;  //Set PWM1 to use clock SA
  PWMPER0 = PWM_PERIOD; //Set Period of PWM1
  PWMDTY0 = 0;  //Begin in off position

  //Left Wheel Motor - Port U1
  MODRR = MODRR|_S12_MODRR1;   //Set PWM1 (U1) to be a PWM port
  PWME = PWME|_S12_PWME1;  //Enable Pulse Width Channel on PWM1
  PWMPOL |= _S12_PPOL1;   //Sets polarity high duty cycle for PWM1
  PWMCLK = PWMCLK | _S12_PCLK1;  //Set PWM1 to use clock SA
  PWMPER1 = PWM_PERIOD; //Set Period of PWM1
  PWMDTY1 = 0;  //Begin in off position

  // Feed Actuator 1 - Port U4
  MODRR = MODRR|_S12_MODRR4;   //Set T0 to be a PWM port
  PWME = PWME|_S12_PWME4;  //Enable Pulse Width
  PWMPOL |= _S12_PPOL4;   //Sets polarity high duty cycle for PWM1
  PWMCLK = PWMCLK | _S12_PCLK4;  //Set PWM2 to use clock SA
  PWMPER4 = PWM_PERIOD; //Set Period of PWM2
  PWMDTY4 = 0;  //Begin in off position
  
  // Feed Actuator 2 - Port U5
  MODRR = MODRR|_S12_MODRR5;   //Set T0 to be a PWM port
  PWME = PWME|_S12_PWME5;  //Enable Pulse Width
  PWMPOL |= _S12_PPOL5;   //Sets polarity high duty cycle for PWM1
  PWMCLK = PWMCLK | _S12_PCLK5;  //Set PWM2 to use clock SA
  PWMPER5 = PWM_PERIOD; //Set Period of PWM2
  PWMDTY5 = 0;  //Begin in off position


  //////////////////////////System B/////////////////////
  PWMPRCLK = (_S12_PCKB0);  //Set PreScaler B to 2
  PWMSCLB = 1;      //Set Post scale factor B

   //Primary Cannon - Port U2
  MODRR = MODRR|_S12_MODRR2;   //Set T0 to be a PWM port
  PWME = PWME|_S12_PWME2;  //Enable Pulse Width
  PWMPOL |= _S12_PPOL2;   //Sets polarity high duty cycle for PWM1
  PWMCLK = PWMCLK | _S12_PCLK2;  //Set PWM2 to use clock SA
  PWMPER2 = PWM_PERIOD; //Set Period of PWM2
  PWMDTY2 = 0;  //Begin in off position


}