// Library of responses 
void ResponseDecoder (unsigned char Response) 
 FirstWord = Response & 0b11110000;
 SecondWord = Response & 0b00001111;
 
 // Filter out the responses
 switch (FirstWord)
 {
    case (0xC0);
      printf("Currently active target is %c\r\n", SecondWord);
      break;
    case (0x40);
      printf("Beacon %c is inactive\r\n", SecondWord);
      break;
    case (0x50);
      printf("Beacon %c is active, but not illuminated\r\n", SecondWord);
      break;
    case (0x60);
      printf("Beacon %c is active, and illuminated\r\n", SecondWord);
      break;
    case (0x70);
      printf("Beacon %c has been hit\r\n", SecondWord);
      break;
    case (0xD0);
      switch (SecondWord)
      {
        case (0x0E);
          printf("Delay, game not yet started or temporarily halted, Stop your robot");
          break;
        case (0x0A);
          printf("Return to your starting box");
          break;
        case (0x0D);
          printf("Game Over, Red Wins");
          break;
        case (0x0C);
          printf("Game Over, Green Wins");
          break;
      }
      break;
    case (0xF0);
      switch (SecondWord)
      {
        case (0x0F);
          printf("Offline");
          break;
        case (0x0B);
          printf("Busy executing last command");
          break;
        case (0x0E);
          printf("Invalid Command Byte Received");
          break;
      }
      break;
    case (0xB0);
      printf("Waiting for Beacon status to return");
      break;
    case (0xE0);
      printf("Waiting for Enable IR response");
      break;
    default:
      //do nothing
      break;
 }
      
     
 
 