#ifndef SPI_h
#define SPI_h

#include "SMEVENTS.h"

typedef enum
{
  ACTIVE,
  DELAY,
  RETURNBOX,
  OVER_RED_WINS,
  OVER_GREEN_WINS,
  OFFLINE,
  BUSY,
  WAIT_FOR_BEACON,
  WAIT_FOR_ENABLE_IR,
  INVALID
} TC_Answer_word_t;

typedef struct
{
  TC_Answer_word_t Response;
  unsigned char ActiveNum;
} TC_Answer_t;



void SPIM_InitializeSPI(void);
void SPI_Transmit(unsigned char);
unsigned char SPI_Transmit_And_Receive(unsigned char command);
unsigned char Request_Beacon_Status(unsigned int);
unsigned char Request_IR_Illumination(unsigned int);
unsigned char Query_Current_Target(void);
//TC_Answer_t Query_Current_Target(void);
Event_t ResponseDecoder (unsigned char Response); 
unsigned char SPIM_TransferByte(unsigned char byteOut);
unsigned char SPI_Transmit_And_Receive2(unsigned char command);

#endif