//#define HARNESS
//#define SPITESTHARNESS
//#define TESTTAPE

#include <hidef.h>      /* common defines and macros */
#include <mc9s12e128.h>     /* derivative information */
#include <stdio.h>
#include <ADS12.h> 
#include <stdlib.h>
#include <S12E128bits.h> /* E128 bit definitions  */
#include <bitdefs.h> /* BIT0HI, BIT0LO....definitions */
#include <stdlib.h>

#include "Movement.h"
#include "Sensors.h"
#include "InitPorts.h"
#include "PWM.h"



#pragma LINK_INFO DERIVATIVE "SampleS12"


//Checks Tape sensors  
int CheckTape(char Sensor)
{

  //The Tape Sensor Numbers correspond to positions on a keypad, however we changed bot orientation,
  // so 1,2,3 are now in front 
  
  
  //           Front
  //           3 2 1       
  //     Left  6 5 4  Right
  //           9 8 7
  //           Back
 
  switch (Sensor)
  {
   
    case 3: //Back Right Sensor
      //printf("3 is called\r\n");
      if((PTS & BIT2HI) == 0)
        return 0;
      else
        return 1;
      break;
    
    case 2: //Back Middle Sensor
      //printf("2 is called\r\n");
      if((PTP & BIT0HI) == 0)
        return 0;
      else
        return 1;
      break;
    
    case 1: //Back Left Sensor
      //printf("1 is called\r\n");
      if((PTP & BIT5HI) == 0) 
        return 0;
      else
        return 1;
      break;
   
    case 5: //Center - Center Sensor
      //printf("5 is called\r\n");
      if((PTS & BIT3HI) == 0)
        return 0;
      else
        return 1;
      break;   

    case 9: //Front Right
      //printf("9 is called\r\n");
      if((PTIAD & BIT1HI) ==0)
        return 0;
      else
        return 1;
      break;  
        
    case 8: //Front Middle Sensor
      //printf("8 is called\r\n");
      if((PTIAD & BIT2HI) ==0)
        return 0;
      else
        return 1;
      break;
    
    case 7: //Front Left Sensor
      //printf("7 is called\r\n");
      if((PTIAD & BIT3HI) ==0)
        return 0;
      else
        return 1;
      break;  
  

  }

  
}


char CheckIR(void)
{
  //printf("3 is called\r\n");
  if(ADS12_ReadADPin(0x07) > 200) 
  if((PTIAD & BIT5HI) == 1)  // see IR
    return 1;
  else
    return 0;  
}



/////////////////////Test Harness///////////////////////////

#ifdef TESTTAPE
void main(void)
{
  InitPorts();
  InitPWM();
  (void)printf("Sensor:  1  2  3  5  7  8  9\n\r");  
  while(1)
  {
    (void)printf(" Value:  %i  %i  %i  %i  %i  %i  %i\r", CheckTape(1), CheckTape(2), CheckTape(3), CheckTape(5), CheckTape(7), CheckTape(8), CheckTape(9));
  }

}
#endif
