/****************************************************************************
 Module
   d:\me218bTNG\Lectures\Lecture31\HierMuWave\MW_ChkEvents.c

 Revision
   1.0.1

 Description
   This is the Event Checking Module for the microwave oven.

 Notes

 History
 When           Who     What/Why
 -------------- ---     --------
 02/20/07 21:37 jec      converted to use enumerated type for events
 02/21/05 15:38 jec      Began coding
****************************************************************************/
#include <stdio.h>
#include <ctype.h>
#include <hidef.h>         /* common defines and macros */
#include <mc9s12e128.h>     /* derivative information */
#include <S12E128bits.h> /* E128 bit definitions  */
#include "ChkEvents.h"
#include "CommunicationsSM.h"
#include "SPI.h"
#include "SMEVENTS.h"
#include "Timers.h"
#include "PlayingSM.h"
#include "Search_And_DestroySM.h"
#include "FiringSM.h"

#define _ms_ *187 

static int ActiveTargetArray[16] = 0;
static int BeaconStatusFlag = 0;
static int ActiveTarget, Count=0;
Event_t CheckEvents(void)
{

  /*Event_t Temporary = CheckSPI();
 
    if( Temporary != EV_NO_EVENT)
    {
    
      (void)printf("Active Target is: %i     Count: %i\n\r", GetTarget(), Count); 
      Count=0;
      return EV_RECIEVED_TARGET;
    }
    Count++;

    static int ActiveTargetArray[16] = 0;
    //static int HitTargetArray[16] =0;
    //Response = SPI_Transmit_And_Receive2(0xAA);
    if ( SPI_TIMER_EXPIRE )
    {
        Response = SPI_Transmit_And_Receive2(0xAA);
        if (ResponseDecoder(Response) != EV_RECIEVED_TARGET) 
        {
          num = (unsigned int)(Response & 0b00001111);
          ActiveTargetArray[num] = 1;
          Request_IR_Illumination(num);
          BeaconStatusFlag = 1;  // Look for hit target
        } 
        // Reset timer
        TIM2_TC5 = TIM2_TCNT + (10 _ms_);
        TIM2_TFLG1 = _S12_C5F; //Clear the OC2 flag
    }   */
    
    /*
    static Event_t OldEvent;
    Event_t CurrentEvent;
    int KeyStroke;
    

    CurrentEvent = ResponseDecoder(GetCommandResponse());
    
    if(CurrentEvent == OldEvent)
    {
      OldEvent = CurrentEvent;
      return EV_NO_EVENT;
    }
    else
    {
      OldEvent = CurrentEvent;
      return CurrentEvent;
    }*/


    if ( kbhit() != 0)       // there was a key pressed
    {
        KeyStroke = getchar();
        switch ( toupper(KeyStroke))
        {
            case 'A' : CurrentEvent = EV_RECIEVED_TARGET; break;
            case 'B' : CurrentEvent = EV_BEACON_INNACTIVE; break;
            case 'C' : CurrentEvent = EV_BEACON_ACTIVE_NOT_ILLUM; break;
            case 'D' : CurrentEvent = EV_BEACON_ACTIVE_ILLUM; break;
            case 'E' : CurrentEvent = EV_BEACON_HIT; break;
            case 'F' : CurrentEvent = EV_GAME_NOT_STARTED; break;
            case 'G' : CurrentEvent = EV_RETURN_TO_BOX; break;
            case 'H' : CurrentEvent = EV_GAME_OVER_RED_WINS; break;
            case 'I' : CurrentEvent = EV_GAME_OVER_GREEN_WINS; break;
            case 'J' : CurrentEvent = EV_OFFLINE; break;
            case 'K' : CurrentEvent = EV_COMMANDER_BUSY; break;
            case 'L' : CurrentEvent = EV_GAME_NOT_STARTED; break;
            case 'M' : CurrentEvent = EV_RETURN_TO_BOX; break;
            case 'N' : CurrentEvent = EV_GAME_OVER_RED_WINS; break;
            
            case 'O' : CurrentEvent = EV_START_GAME; break;
            case 'P' : CurrentEvent = EV_RETURN_HOME; break;
            case 'Q' : CurrentEvent = EV_REACH_HOME; break;
            case 'R' : CurrentEvent = EV_GAME_OVER; break;
            
            (void)printf("Received Keyboard input");
        }  
        return(CurrentEvent);
    }  
    /*

    if( QueryTapeFoundFlag() == 1)
    {
       return EV_TAPE_FOUND;
    }
    
    
    if( QueryTapeAlignedFlag() == 1 )
    { 
      return EV_TAPE_ALIGNED;
    }
    
    
    if( QueryTIntersectFlag() == 1 )
    {
      return EV_TIntersect_FOUND;
    }
    
    if ( QueryAngleFlag() == 0)
    {
      return EV_ROTATE_DONE;
    }
    
    if ( QueryFireFlag() == 1)
    {
      printf("FireFlag is set in checkEvents\r\n");
      return EV_BALL_IS_RELEASED;
    }        
    */
    return EV_NO_EVENT;
}
/*
Event_t CheckSPI()
{
  unsigned char Response;
  static int OldNum=0;
  int num, BeaconStatusFlag;
  Event_t NewEvent;
    //Response = SPI_Transmit_And_Receive2(0xAA);
    
    if ( SPI_TIMER_EXPIRE )
    {
    
        Response = SPI_Transmit_And_Receive2(0xAA);
        NewEvent = ResponseDecoder(Response);
        if (NewEvent == EV_RECIEVED_TARGET) 
        {
        
          num = (unsigned int)(Response & 0b00001111);
          printf("num is %i\r\n", num);
          ActiveTargetArray[num] = 1;
          ActiveTarget = num;
          //Request_IR_Illumination(num);
          BeaconStatusFlag = 1;  // Look for hit target
          
          if(OldNum != num)
          {
            //(void)printf("OldNum:   %i   NewNum:  %i", OldNum, num);
            // Reset timer
            TIM2_TC5 = TIM2_TCNT + (300 _ms_);
            TIM2_TFLG1 = _S12_C5F; //Clear the OC2 flag
            OldNum = num; 
            return NewEvent;
          }
        } 
        
        //Reset Timer
        TIM2_TC5 = TIM2_TCNT + (300 _ms_);  
        TIM2_TFLG1 = _S12_C5F; //Clear the OC2 flag
    } 
    
      //(void)printf("No Event");
      return EV_NO_EVENT;
}

*/
int GetTarget(void)
{
    return  ActiveTarget;
}
  





    
