//#define TestSandDSM
/****************************************************************************
 Module
   d:\me218bTNG\Lectures\Lecture31\SMTemplateMain.c

 Revision
   1.0.1

 Description
   This is a template file for a main() implementing state machines.

 Notes

 History
 When           Who     What/Why
 -------------- ---     --------
 03/17/09 10:20 jec      added cast to return from RunTemplateSM() to quiet
                         warnings because now that function returns Event_t
 02/11/05 16:56 jec      Began coding
****************************************************************************/
#include "CommunicationsSM.h"


#include "DeadReckoning.h"
#include "Sensors.h"
#include "Movement.h"

#include "Timers.h"
#include "PWM.h"
#include "InitPorts.h"
#include "Constants.h"
#include "SPI.h"
#include "ChkEvents.h"
#include "SPI_On_SM.h"

#include <stdio.h>


#ifdef TestSandDSM
void main (void)
{
    // Do any hardware system initialization

  (void)printf("Beginning the communication test\n\r");
    InitPorts();
    InitTimers();
    InitPWM();
    SPIM_InitializeSPI();

    InitConstants();
    
    // do the master state machine initialization
    StartCommunicationsSM();
    
    // check for and handle events
    while (1)
    {
        (void)RunCommunicationsSM(CheckEvents());
        
    }
}
#endif

